package prupp;

// $Id: Sender.java,v 1.1.1.1 1998/08/10 21:13:36 d94-rol Exp $

import java.util.*;
import java.io.*;
import java.net.*;
import prupp.html.*;

/** This class sends filtered data to the assigned outputstreams.
 */
public class Sender
{
    private DataOutputStream os;
    private DataOutputStream cache;
    private StringBuffer in = new StringBuffer ();
    private StringBuffer rest = new StringBuffer ();
    private URL url;
    private Vector fl;
    
    /** The standard constructor.
     * @param os the standard stream to send to.
     * @param cache the cachefile if any (null = no cache).
     * @param url the URL were writing from
     */
    public Sender (DataOutputStream os, DataOutputStream cache, URL url) {
	this.os = os;
	this.cache = cache;
	this.url = url;
	fl = Proxy.getFilters(url);
    }
    
    /** Add text to handle
     * @param v the bytes we want handled
     * @param i the number of bytes to add (OBS this need not be v.size)
     */
    public void addText (byte[] v, int i) {
	in.append(new String(v,0,i));
    }
    
    /** Handle the text by filtering it and also sending it.  
     */
    public void filter () throws IOException {
	String wrkstr = rest.toString () + in.toString ();
	HTMLBlock htmlb = new HTMLBlock (wrkstr);
	in.setLength (0);
	rest.setLength (0);
	HTMLBlock block = new HTMLBlock (wrkstr);
	String brest = block.getRest ();
	if (brest != null)
	    rest.append (block.getRest ());
	for (int i = 0; i < fl.size(); i++) {
	    // if we get anything back insert it in right order for next round.
	    String frest = ((prupp.filter.Filter) fl.elementAt(i)).filter(block);
	    if (frest != null)
		rest.insert (0, frest); 
	}
	send (block.toString ());
    }
/*
	String wrkstr = rest.toString() + in.toString();
	in.setLength(0);
	rest.setLength (0);
	int llt = wrkstr.lastIndexOf ('<');
	int lgt = -1;
	if (llt >= 0 && 
	    ((lgt = wrkstr.lastIndexOf ('>')) > 0) && 
	    (llt > lgt)) {
	    rest.append (wrkstr.substring (llt));
	    wrkstr = wrkstr.substring (0,llt);
	}
	StringWrapper work = new StringWrapper (wrkstr);
/*	HTMLBlock htmlb = new HTMLBlock (wrkstr);
	prupp.filter.Filter f = new prupp.filter.BodyFilter (url);
	f.filter (htmlb);
	f = new prupp.filter.BackgroundFilter ();
	f.filter (htmlb);*/
	
/**	System.out.println ("wrkstr:\n" + wrkstr); 
	System.out.println ("*****************************\n" + htmlb);
		
	for (int i = 0; i < fl.size(); i++)
	    // if we get anything back insert it in right order for next round.
	    rest.insert (0, ((Filter) fl.elementAt(i)).filterText(work)); 
	    send (work.getText ());
	    } 
*/
    
    /** Send the text out on the streams we have.
     * @param s the String were sending out.
     */
    private void send (String s) throws IOException {
	os.write(s.getBytes ());  // dont do os.writeBytes (s) its a magnitude slower!!!

	if (cache != null)
	    cache.write (s.getBytes ());
    }    

    /** Sends any remaining text (Filters may leave data they are uncertain about).
     */
    public void cleanup() {
	try {
	    send (rest.toString ());
	} catch (IOException e) {
	    Proxy.logError ("Sender.cleanup: " + e.toString ());
	}
    }
}
