package prupp;

// $Id: Status.java,v 1.6 1998/12/19 13:46:10 d94-rol Exp $

import java.io.*;
import java.net.*;
import java.util.*;

/** the Metapage that shows the status of the proxy.
 */
public class Status implements MetaHandler {
    /** default constructor */
    public Status () {
    }

    /** handler of a MetaPage.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param url the requested url.
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param uap the username and paswword as by Basic-authentication
     */
    public void handle (DataInputStream input, DataOutputStream output, URL url, Properties htab, String uap) {
	try {      
	    Vector convec = Proxy.getCurrentConections ();
	    StringBuffer res = new StringBuffer (Proxy.getHeader ().toString () +
						 HTMLPage.getPageHeader ("Status") +
						 "Version: " + Proxy.VERSION + "<br>\n" +
						 "Started at: " + Proxy.getStartDate () + "<br>\n" +
						 "Current time: " + new Date () + "<br>\n" +
						 "Alive and kicking with " + convec.size () + " current " +
						 "connections.<br>\n" +
						 "I have served a total of " + Proxy.getNoOfServedPages () + " accesses<br>\n"+
						 "Cachedir   : " + Proxy.getCache ().getCacheDir () + "<br>\n" + 
						 HTMLPage.getTableHeader (100, 1) +
						 HTMLPage.getTableTopicRow () + 
						 "<th width=\"20%\">InetAddress</th><th width=\"50%\">Connection</th>" +
						 "<th width=\"20%\">Status</th><th>Time(s)</th></tr>\n");
	    long now = new Date ().getTime ();
	    for (int i = 0; i < convec.size (); i++) {
		HTTPHeaderHandler hth = (HTTPHeaderHandler)convec.elementAt (i);
		res.append ("<tr><td>" + hth.getInetAddress ().getHostAddress () + 
			    "</td><td>"+ hth.getConnection () +
			    "</td><td>" + hth.getStatus () + 
			    "</td><td>" + ((now - hth.getStarted ().getTime())/1000) + "</td></tr>\n");
	    }
	
	    res.append ("</table>\n<br>\n" + HTMLPage.getTableHeader (100, 1) + HTMLPage.getTableTopicRow ());
	    res.append ("<th>thingy</th><th width=\"10%\">times</th></tr>\n");
	
	    // add the logged things.
	    Enumeration e = Proxy.getLogger ().keys ();
	    while (e.hasMoreElements ()) {
		String type = (String) e.nextElement ();
		int val = Proxy.getLogger ().get (type);
		res.append ("\t<tr><td>" + type + "</td><td>" + val + "</td></tr>\n");
	    }
	
	    res.append ("</table>\n</body></html>");
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write status");
	}
    }
}
