package prupp.filter;

// $Id$

import java.util.*;
import prupp.html.*;

/** Remove advertising from pages.
 */
public class AdFilter extends Filter
{
    /** the vector of ad-sites */
    protected static Vector evil;
    /** the image we replace ads with */
    protected static String adreplacer = "http://www.student.nada.kth.se/~d94-rol/pics/NoAd.gif";

    /** constructor */
    public AdFilter () {
    }

    /** Filter away Advertising.
     * @param block the HTMLBlock were about to filter.
     * @return the uncertain area of the block.
     */
    public String filter(HTMLBlock block) {
	StringBuffer restbuf = null;
	boolean rest = false;
	
	Vector tags = block.getElements ();
	for (int i = 0; i < tags.size (); i++) {
	    Object o = tags.elementAt (i);
	    if (!isString (o)) {
		HTMLTag tag = (HTMLTag)o;
		if (tag.getType ().equals ("A")) {
		    String src = tag.getAttribute ("HREF");
		    if (src != null) {
			src = src.toLowerCase ();
		    outer: 
			for (int k = 0; k < evil.size (); k++) {
			    if (src.indexOf ((String)evil.elementAt (k)) >= 0) {
				int astart = i;
				for (; i < tags.size (); i++) {
				    Object o2 = tags.elementAt (i);
				    if (!isString (o2)) {
					HTMLTag tag2 = (HTMLTag)o2;
					if (tag2.getType ().equals ("/A")) {
					    break outer;
					}
					else if (tag2.getType ().equals ("IMG")) {
					    tag2.setAttribute ("SRC", adreplacer);
					}
				    }
				}
				if (i == tags.size ()) {
				    restbuf = new StringBuffer ();
				    rest = true;
				    for (i = tags.size (); i > astart; i--) {
					Object o2 = tags.elementAt (astart);
					restbuf.append (o2.toString ());
					tags.removeElementAt (astart);
				    }
				}
			    }
			}
		    }
		} else if (tag.getType ().equals ("LAYER")) {
		    String src = tag.getAttribute ("SRC");
		    if (src != null) {
			src = src.toLowerCase ();
			for (int k = 0; k < evil.size (); k++) 
			    if (src.indexOf ((String)evil.elementAt (k)) >= 0) 
				tag.setAttribute ("SRC", adreplacer);
		    }
		}
	    }
	}
	if (rest)
	    return restbuf.toString ();
	return null;
    }
  
    /** Called when you want to setup how this filter should work.
     * @param properties the properties to use.
     */
    public static void setup (Properties properties) {
	if (properties.getProperty ("adreplacer") != null)
	    adreplacer = properties.getProperty ("adreplacer");
	if (properties.getProperty ("adlinks") != null) {
	    evil = new Vector ();
	    StringTokenizer st = new StringTokenizer (properties.getProperty ("adlinks"), ",");
	    while (st.hasMoreElements ()) 
		evil.addElement (st.nextToken ());
	}
    }

    /** Called when you want to get the possible settings this filter 
     *  support. 
     */
    public static Properties getProperties () {
	Properties ret = new Properties ();
	ret.put ("adreplacer", adreplacer);
	StringBuffer ads = new StringBuffer();
	for (int i = 0; i < evil.size (); i++) {
	    ads.append (evil.elementAt (i).toString());
	    if (i < evil.size () - 1)
		ads.append (',');
	}
	ret.put ("adlinks", ads.toString());
	return ret;
    }
}

